// LICENSE : MIT
"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

require('array.prototype.find').shim();
/**
 * @param {ModifiedDiff} modifiedDiff
 */
var defaultPrePredicate = function defaultPrePredicate(modifiedDiff) {
    var filterWord = /typo/;
    return filterWord.test(modifiedDiff.commitMessage);
};
/**
 * @param {ModifiedTokenDiff} modifiedTokenDiff
 */
var defaultPostPredicate = function defaultPostPredicate(modifiedTokenDiff) {
    var diffLimit = 3;
    if (modifiedTokenDiff.newTokens.length > diffLimit) {
        return false;
    }
    // 記号周りの経脳は無視
    var ignoreRegExp = /[!"#$%&'()\*\+\-\.,\/:;<=>?@\[\\\]^_`{|}~a-zA-Z0-9]/;
    if (ignoreRegExp.test(modifiedTokenDiff.oldText) || ignoreRegExp.test(modifiedTokenDiff.newText)) {
        return false;
    }
    // 接続詞を句点に変える変更は無視
    var oldMiddleToken = modifiedTokenDiff.oldTokens[1];
    var newMiddleToken = modifiedTokenDiff.oldTokens[1];
    var tenRegExp = /[、。]/;
    if (tenRegExp.test(oldMiddleToken.surface_form) || tenRegExp.test(newMiddleToken.surface_form)) {
        return false;
    }
    return true;
};

/**
 * @param {ModifiedTokenDiff[]} modifiedTokenDiffs
 */
var unique = function unique(modifiedTokenDiffs) {
    var results = [];
    modifiedTokenDiffs.forEach(function (modifiedTokenDiff) {
        var matchText = modifiedTokenDiff.oldText + "|" + modifiedTokenDiff.newText;
        var foundDiff = results.find(function (target) {
            return matchText === target.oldText + "|" + target.newText;
        });
        if (!foundDiff) {
            results.push(modifiedTokenDiff);
        }
    });
    return results;
};

var DiffFilter = function () {
    function DiffFilter() {
        _classCallCheck(this, DiffFilter);
    }

    _createClass(DiffFilter, null, [{
        key: "preFilter",

        /**
         * @param {ModifiedDiff[]} modifiedDiffs
         * @param {function(ModifiedDiff):boolean}predicate
         */
        value: function preFilter(modifiedDiffs) {
            var predicate = arguments.length <= 1 || arguments[1] === undefined ? defaultPrePredicate : arguments[1];

            return modifiedDiffs.filter(predicate);
        }

        /**
         * @param {ModifiedTokenDiff[]} modifiedTokenDiffs
         * @param {function(ModifiedTokenDiff):boolean}predicate
         */

    }, {
        key: "postFilter",
        value: function postFilter(modifiedTokenDiffs) {
            var predicate = arguments.length <= 1 || arguments[1] === undefined ? defaultPostPredicate : arguments[1];

            return modifiedTokenDiffs.filter(predicate);
        }
    }]);

    return DiffFilter;
}();

exports.default = DiffFilter;
//# sourceMappingURL=DiffFilter.js.map